// Google Icon v1.9 -- Sean Catchpole
//  This script made possible by:
//    All the great tutorials on mozilla's website
//    http://developer.mozilla.org/en/docs/Code_snippets:On_page_load
// Malware idea: http://www.customizegoogle.com/add-favicons-to-google-search-results.html
// Icons from: http://www.famfamfam.com/lab/icons/silk/
// To stop authentication error use Image() not createElement("img")
// Anonymous functions are useful for creating new scopes
// Delay allows other extensions to parse the page unmodified
(function(){

var googleicon = function(doc) {
  if(doc.location.href.match(/^http:\/\/.*\.google\..*\/search?.*$/i)) {

    // Check if already loaded
    if(doc.getElementById("googleicon")) return;

    // Create Google Icon
    var div = doc.createElement("div");
    div.id = "googleicon";
    doc.body.appendChild(div);

    // Find results
    var results = doc.evaluate("//*[@class='g']//a[@class='l']", doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
    for(var i=0; i<results.snapshotLength; ++i) {
      var result = results.snapshotItem(i);

      // Find url
      var url = result.href.replace(/<\S[^><]*>/g,"");
      if(/^http:\/\/.*\.google\..*\/url?.*$/i.test(url))
        url = url.match(/&q=(.*?)&/)[1];
      var safe = (url.indexOf("https://")<0);
      if(url.match("google.com/interstitial?"))
           url = "chrome://googleicon/content/malware.png";
      else url = "http://"+url.split('/')[2]+"/favicon.ico";

      // Add icon
      (function(url){
        var img = new Image();
        img.width = 16; img.src = "chrome://googleicon/content/blank.png";
        img.className = "googleicon";
        img.setAttribute("style","border:0; padding-top:2px; padding-right:4px; display:block; float:left;");
        result.insertBefore(img, result.firstChild);
        if(safe) {
          var newimg = new Image(); newimg.src = url;
          newimg.addEventListener("load", function(){ img.src = url; }, false);
        }
      })(url);

} } };

// Bind Google Icon
var delay = function(aEvent){ var doc = aEvent.originalTarget; setTimeout(function(){ googleicon(doc); },1); };
var load = function(){ gBrowser.addEventListener("DOMContentLoaded", delay, true); };
window.addEventListener("pageshow", load, false);

})();
